/*****************************************************************************
**
** process_set_attributes.cpp
**
*****************************************************************************/
#include <stdio.h> 
#include <uf.h>
#include <uf_defs.h>
#include <uf_exit.h>
#include <uf_ui.h>
#include <uf_styler.h>
#include <uf_mb.h> 

#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "process_set_attributes.h"

FILE*	prterr;
int			errorCode;
int			flag_fastspectrum;	//1 -    (..  );
								//0  -   Cansel(   );

int			choise_DIALOG;		//. -   set_all_IPAC_attributes
								//OK -1;  Cancel - 0;

char**		rivet_attr;			//   -  -  
int			ind_rivet;			//     

char**		pr_code_attr;		//   -  -  
int			ind_pr_code;

char**		ad_code_attr;		//   -  -  
int			ind_ad_code;

char**		fast_code_attr;		// Fastener Code -  -  
int			ind_fast_code;

int			ind_grip_lng;

char	*atr_rivet;			    //. . .  rivet		-	 
char	*atr_pr_code;			//. . .	pr_code		-	 
char	*atr_ad_code;			//. . .  ad_code		-	 
char	*atr_fast_code;			//. . .	fast_code	-	 
char	*atr_grip_lng;			//. . .	grip_lng	-	 
double	num_DLINA;				//. . .	grip_lng	-	 

#define	PRTERR(line)if(errorCode){PrintErrorMessage(errorCode,line);errorCode=0;goto term;}
#define	PRTERR_END(line)if(errorCode){PrintErrorMessage(errorCode,line);}


void	PrintErrorMessage( int errorCode, int line );
/***************************************************************************/
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
 /*
 

1.	C         :
	D:\\prterr.txt, C:\\Temp\\prterr.txt

2.	    UF... .

3.	 .

4.	  DIALOG_set_attributes()   .

5.	    (DIALOG_set_attributes()  1) - 
	 set_attr_to_comp() -  .
	     (DIALOG_set_attributes()  0) - 
	 .

6.	  - 
*/

int temp=0;

char*	pattern=	"\nCPU_time   =	 %d     = %d"
						"\nReal_time  = \t %d     = %d\n";


//  --------------------------------------------------
if((prterr=fopen("D:\\prterr.txt","w"))!=NULL)
   sprintf(prterr_path,"     - D:\\prterr.txt");
   else
   {
	   if((prterr=fopen("C:\\Temp\\prterr.txt","w"))!=NULL)
		    sprintf(prterr_path,"     - C:\\Temp\\prterr.txt");
			else
			{
			if((prterr=fopen("C:\\temp\\prterr.txt","w"))!=NULL)
				sprintf(prterr_path,"     - C:\\temp\\prterr.txt");
				else
				{
				 uc1601("     - D:\\, C:\\Temp\\, C:\\temp\\",1);
				 return;
				}
			}
   }

	//    ------------------------------------------
	fprintf(prterr,"process_set_attributes	\tstarted	\tline=%d\n",__LINE__);
	time(&aclock);				//get time in seconds
	newtime=localtime(&aclock);	//convert time to struct
	fprintf(prterr,"The current date and time are:	%s\n",asctime(newtime));

	//    UF... -----------------------------
	errorCode=UF_initialize();PRTERR(__LINE__);

	// ------------------------------------------------------
	errorCode=UF_begin_timer(&timer);PRTERR(__LINE__);
	
	choise_DIALOG=0;
		
	errorCode = DIALOG_set_attributes (&temp);	PRTERR(__LINE__);
			  	
	// 
	fprintf(prterr,"GLOBAL -> atr_rivet=%s\n", atr_rivet);
	fprintf(prterr,"GLOBAL -> atr_pr_code=%s\n", atr_pr_code);
	fprintf(prterr,"GLOBAL -> atr_ad_code=%s\n", atr_ad_code);
	fprintf(prterr,"GLOBAL -> atr_fast_code=%s\n", atr_fast_code);
	fprintf(prterr,"GLOBAL -> atr_grip_lng=%s\n", atr_grip_lng);
	fprintf(prterr,"GLOBAL -> num_DLINA=%.2f\n\n", num_DLINA);

	if( choise_DIALOG == 1 )
		{ errorCode = set_attr_to_comp();	PRTERR(__LINE__); }

term:
#define	CPUTIME1		(int)values.cpu_time/60
#define CPUTIME2		(int)values.cpu_time%60
#define REALTIME1		(int)values.real_time/60
#define REALTIME2		(int)values.real_time%60
    
	//    
	errorCode=UF_end_timer(timer,&values);PRTERR_END(__LINE__);
	fprintf(prterr,"\n\n");
	fprintf(prterr,pattern,CPUTIME1,CPUTIME2,REALTIME1,REALTIME2);
	//    
	errorCode=UF_UI_set_status(prterr_path);PRTERR_END(__LINE__);
	//    UF... 
	errorCode=UF_terminate();PRTERR_END(__LINE__);
	fprintf(prterr,"process_set_attributes	\tended	\tline=%d\n",__LINE__);

	
	//  	
	fflush(prterr);				PRTERR(__LINE__);
	fclose(prterr);				PRTERR(__LINE__);	

}//void ufusr

/**************************************************************************/
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}

/************************************************************************/
void PrintErrorMessage( int errorCode, int line )
{

	char*	pattern="%s \terrorCode=%d \tline=%d  %s\n";

    if ( 0 != errorCode )
    {
        /* Retrieve the associated error message */
        char message[133];
        UF_get_fail_message( errorCode, message );

        /* Print out the message */
        UF_UI_set_status( message );

        fprintf( prterr, pattern, message, errorCode, line, __FILE__ );
    }
}

