/*
set_IPAC_fastspectrum.cpp

  " "
 :
1.	extern int Dialog_set_fastspectrum ( int *response )
										 

2.	int FAST_create_list ( )
				 .    fast_code( )
				   grip_lng.

3.  int FAST_OK_cb ( )
			   .
			..      " ".
			  :
						-	   atr_grip_lng="080"
						-         num_DLINA=8.0
 
4.	int FAST_Cansel_cb ( )
			  Cansel.
			..       " ".
			   0.0
			num_DLINA=0.0	
			atr_grip_lng = "000"  !!!!!!!!!!!!  
 */
#include <stdio.h> 
#include <stdlib.h>
#include <string.h>

#include <uf.h>
#include <uf_defs.h>
#include <uf_exit.h>
#include <uf_ui.h>
#include <uf_styler.h>
#include <uf_mb.h> 

#include "set_IPAC_fastspectrum.h"

extern char *str3404579D35[];		//5
extern char *str3404579D40[];		//4
extern char *str3404579D50[];		//5
	

extern char *str3404680D35[];		//5
extern char *str3404680D40[];		//5
extern char *str3404680D50[];		//5


extern char *str3404480D40[];		//2
extern char *str3404480D50[];		//8
extern char *str3404480D60[];		//9


extern char *str3004787D50[];		//3
extern char *str3004787D60[];		//6


extern char *str3004887D50[];		//5


extern char *str3004887D60[];		//8
extern char *str3004887D80[];		//10


extern char *str163768D35[];		//5


extern char *str163768D40[];		//5


extern int str3404579D35_cnt;
extern int str3404579D40_cnt;
extern int str3404579D50_cnt;


extern int str3404680D35_cnt;
extern int str3404680D40_cnt;
extern int str3404680D50_cnt;

extern int str3404480D40_cnt;
extern int str3404480D50_cnt;
extern int str3404480D60_cnt;

extern int str3004787D50_cnt;
extern int str3004787D60_cnt;

extern int str3004887D50_cnt;

extern int str3004887D60_cnt;
extern int str3004887D80_cnt;

extern int str163768D35_cnt;

extern int str163768D40_cnt;


extern	int			errorCode;
extern	int			flag_fastspectrum;

extern  int			ind_fast_code;
extern  int			ind_grip_lng;
extern	char		*atr_grip_lng;			
extern	double		num_DLINA;


extern				FILE*	prterr;

//********************************************************************

#define	PRTERR(line)if(errorCode)\
	{PrintErrorMessage(errorCode,line);errorCode=0;goto term;}


//********************************************************************
static void PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char	message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"errorCode=%d	message=%s		line=%d	\n",
			errorCode,message,line);
	}
}

//********************************************************************
#define FAST_CB_COUNT ( 3 + 1 ) /* Add 1 for the terminator */


static UF_STYLER_callback_info_t FAST_cbs[FAST_CB_COUNT] = 
{
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CONSTRUCTOR_CB  , 0, FAST_create_list},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_OK_CB           , 0, FAST_OK_cb},
 {UF_STYLER_DIALOG_INDEX, UF_STYLER_CANCEL_CB       , 0, FAST_Cansel_cb},
 {UF_STYLER_NULL_OBJECT, UF_STYLER_NO_CB, 0, 0 }
};


static UF_MB_styler_actions_t actions[] = {
    { "set_IPAC_fastspectrum.dlg",  NULL,   FAST_cbs,  UF_MB_STYLER_IS_NOT_TOP },
    { NULL,  NULL,  NULL,  0 } /* This is a NULL terminated list */
};





//********************************************************************
extern int Dialog_set_fastspectrum ( int *response )
{//  
    int  error_code = 0;
 
    if ( ( error_code = UF_initialize() ) != 0 ) 
           return (0) ;

    if ( ( error_code = UF_STYLER_create_dialog ( "D:\\application\\set_IPAC_fastspectrum.dlg",
           FAST_cbs,      /* Callbacks from dialog */
           FAST_CB_COUNT, /* number of callbacks*/
           NULL,        /* This is your client data */
           response ) ) != 0 )
    {
          char fail_message[133];

          /* Get the user function fail message based on the fail code.*/
          UF_get_fail_message(error_code, fail_message);
          UF_UI_set_status (fail_message);
          printf ( "%s\n", fail_message ); 
    }


    UF_terminate();                             
    return (error_code);
}

//*********************************************************************
int FAST_create_list ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{/*
	 .
	  fast_code    grip_lng.
 */

UF_STYLER_item_value_type_t	value;

     
if ( UF_initialize() != 0) 
     return ( UF_UI_CB_CONTINUE_DIALOG );

   
     /*   ,    */
		value.item_attr=UF_STYLER_SUBITEM_VALUES;
		value.item_id = "GRIP_LNG";
		
		switch ( ind_fast_code )
		{case	0:	value.value.strings=str3404579D35; 
					value.count=str3404579D35_cnt;
					break;
		
		case	1:  value.value.strings=str3404579D40; 
					value.count=str3404579D40_cnt;
					break;
		
		case	2:  value.value.strings=str3404579D50; 
					value.count=str3404579D50_cnt;
					break;

		case	3:  value.value.strings=str3404680D35; 
					value.count=str3404680D35_cnt;
					break;
		
		case	4:  value.value.strings=str3404680D40; 
					value.count=str3404680D40_cnt;
					break;
		
		case	5:  value.value.strings=str3404680D50; 
					value.count=str3404680D50_cnt;
					break;

		case	6:  value.value.strings=str3404480D40; 
					value.count=str3404480D40_cnt;
					break;
		
		case	7:  value.value.strings=str3404480D50; 
					value.count=str3404480D50_cnt;
					break;
		
		case	8:  value.value.strings=str3404480D60; 
					value.count=str3404480D60_cnt;
					break;

		case	9:  value.value.strings=str3004787D50; 
					value.count=str3004787D50_cnt;
					break;
		
		case	10: value.value.strings=str3004787D60; 
					value.count=str3004787D60_cnt;
					break;

		case	11: value.value.strings=str3004887D50; 
					value.count=str3004887D50_cnt;
					break;

		case	12: value.value.strings=str3004887D60; 
					value.count=str3004887D60_cnt;
					break;
		
		case	13: value.value.strings=str3004887D80; 
					value.count=str3004887D80_cnt;
					break;

		case	14: value.value.strings=str163768D35; 
					value.count=str163768D35_cnt;
					break;
		
		case	15: value.value.strings=str163768D40; 
					value.count=str163768D40_cnt;
					break;
		}
		
		errorCode=UF_STYLER_set_value(dialog_id, &value);  PRTERR(__LINE__);
		//fprintf(prterr,"\n FAST_create_list - \n");

term:
	UF_terminate ();

	return (UF_UI_CB_CONTINUE_DIALOG); 
    
}


//**************************************************************************
int FAST_OK_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{/* 
	   -   " ".
	..      " ".
	  .      (. str_grip_length="8.0").
	  :
	-	   atr_grip_lng="080"
	-         
		num_DLINA=8.0(num_DLINA=atof(str_grip_length));
 
 */

int		flag=0;
char	*str_grip_length;			

    
if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

  /*  ( 0)     */
  callback_data->item_attr=UF_STYLER_VALUE;
  callback_data->item_id = "GRIP_LNG";
  errorCode=UF_STYLER_ask_value(dialog_id, callback_data);	PRTERR(__LINE__);
  ind_grip_lng=callback_data->value.integer;
  //fprintf(prterr,"styler_fastspectrum.cpp -     =%d\n",ii);
	
  //  ( -  )   
  callback_data->item_attr=UF_STYLER_SUBITEM_VALUES;
  callback_data->item_id = "GRIP_LNG";
  errorCode=UF_STYLER_ask_value(dialog_id, callback_data);	PRTERR(__LINE__);
  str_grip_length = callback_data->value.strings[ind_grip_lng];
  //fprintf(prterr,"\nFAST_OK_cb -    str_grip_length=%s    \n", str_grip_length);

  //   "8.0"    "080"     . 
flag=0;

			if ( (errorCode=strcmp(str_grip_length, "8.0")) == 0 ) { atr_grip_lng="080";    flag=flag+1;  }					
			if ( (errorCode=strcmp(str_grip_length, "9.5")) == 0 ) { atr_grip_lng="095";   flag=flag+1;   }			
			if ( (errorCode=strcmp(str_grip_length, "11.0")) == 0 ) { atr_grip_lng="110";  flag=flag+1;   }

			if ( (errorCode=strcmp(str_grip_length, "12.5")) == 0 ) { atr_grip_lng="125";  flag=flag+1;   }
			if ( (errorCode=strcmp(str_grip_length, "14.0")) == 0 ) { atr_grip_lng="140";  flag=flag+1;   }
			if ( (errorCode=strcmp(str_grip_length, "15.5")) == 0 ) { atr_grip_lng="155";  flag=flag+1;   }
			if ( (errorCode=strcmp(str_grip_length, "17.0")) == 0 ) { atr_grip_lng="170";  flag=flag+1;  }
			if ( (errorCode=strcmp(str_grip_length, "18.5")) == 0 ) { atr_grip_lng="185";  flag=flag+1;  }
			
			if ( (errorCode=strcmp(str_grip_length, "20.0")) == 0 ) { atr_grip_lng="200";  flag=flag+1;  }
			if ( (errorCode=strcmp(str_grip_length, "21.5")) == 0 ) { atr_grip_lng="215";  flag=flag+1;  }
			if ( (errorCode=strcmp(str_grip_length, "23.0")) == 0 ) { atr_grip_lng="230";  flag=flag+1;  }

			if ( (errorCode=strcmp(str_grip_length, "36.0")) == 0 ) { atr_grip_lng="360";  flag=flag+1;  }
			if ( (errorCode=strcmp(str_grip_length, "37.0")) == 0 ) { atr_grip_lng="370";  flag=flag+1;  }
			if ( (errorCode=strcmp(str_grip_length, "39.0")) == 0 ) { atr_grip_lng="390";  flag=flag+1;  }

			if ( (errorCode=strcmp(str_grip_length, "40.0")) == 0 ) { atr_grip_lng="400";  flag=flag+1;  }
			if ( (errorCode=strcmp(str_grip_length, "42.0")) == 0 ) { atr_grip_lng="420";  flag=flag+1;  }
			if ( (errorCode=strcmp(str_grip_length, "43.0")) == 0 ) { atr_grip_lng="430";  flag=flag+1;  }
			if ( (errorCode=strcmp(str_grip_length, "45.0")) == 0 ) { atr_grip_lng="450";  flag=flag+1; }
			if ( (errorCode=strcmp(str_grip_length, "46.0")) == 0 ) { atr_grip_lng="460";  flag=flag+1;  }
			if ( (errorCode=strcmp(str_grip_length, "48.0")) == 0 ) { atr_grip_lng="480";  flag=flag+1;  }
			
			fprintf(prterr,"\nFAST_OK_cb - atr_grip_lng=%s   str_grip_length=%s   flag=%d\n", atr_grip_lng, str_grip_length, flag);
					
			if (flag==0)	
			{	fprintf(prterr,"\nFAST_OK_cb -     - atr_grip_lng=000 ");
				atr_grip_lng="000";
				goto term;
			}
			else
			{
				if (flag>1)	
					{	fprintf(prterr,"\nFAST_OK_cb-    >1 - atr_grip_lng=000 ");
						atr_grip_lng="000";
						goto term;
					}
			}
			
  num_DLINA=atof(str_grip_length);
  flag_fastspectrum=1;

  fprintf(prterr,"FAST_OK_cb  - atr_grip_lng=%s  num_DLINA=%.2\n", atr_grip_lng, num_DLINA);


term:
     UF_terminate ();

     return (UF_UI_CB_EXIT_DIALOG);                           

}


//*******************************************************************************
int FAST_Cansel_cb ( int dialog_id,
             void * client_data,
             UF_STYLER_item_value_type_p_t callback_data)
{
/* 
	  Cansel -   " ".
	..       " ".
	
	   0.0
	num_DLINA=0.0	
	atr_grip_lng = "000"
 */
 char	*str_grip_length;			
    
     if ( UF_initialize() != 0) 
          return ( UF_UI_CB_CONTINUE_DIALOG );

  
  str_grip_length = "000";
  atr_grip_lng = "000";
  num_DLINA=atof(str_grip_length);

  flag_fastspectrum=0;
  fprintf(prterr,"FAST_Cansel_cb  - atr_grip_lng=%s  num_DLINA=%.2\n", atr_grip_lng, num_DLINA);

  UF_terminate ();

    
  return ( UF_UI_CB_EXIT_DIALOG );                       
}